# This file is automatically generated by gen_stub.rs

from typing import final, Any, List, Dict
from enum import Enum, auto

@final
class Miplib:
    r"""
    MIPLIB dataset
    
    Examples
    ---------
    ```python
    >>> import jijmodeling.dataset
    
    Download if not cached in your filesystem. It will take several minutes.
    >>> miplib = jijmodeling.dataset.Miplib()
    
    Show names of each dataset
    >>> miplib.available_names  # doctest: +ELLIPSIS
    [...]
    
    Dict of name to instance statistics defined in https://miplib.zib.de/statistics.html
    >>> miplib.instance_statistics["unitcal_7"]
    {'variable': 25755, 'constraint': 48939, 'binary': 2856, 'integer': 0, 'continuous': 22899, 'non_zero': 127595}
    
    Load "revised-submissions/miplib2010_pg/instances/pg.mps.gz" in benchmark.zip
    >>> problem, instance_data = miplib.load("pg")
    
    ```
    """
    available_names: List[str]
    instance_statistics: Any
    def __new__(cls,verbose = ...): ...
    def load(self, name) -> Any:
        r"""
        Load a problem from MIPLIB dataset.
        """
        ...


